CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  file_info_serial = 1
  file_info_fileio = 2
  
  file_info_type   = 0
  file_info_data   = 1
  file_info_size   = 8

OBJ
  rendez : "rendezvous"
  fileio : "cfileio_os"
  mem : "cmalloc"
  ser : "cserial"
  conio : "conio"

PUB main | argv1[2]
  longfill(rendez#start, 0, ($8000 - rendez#start) >> 2)
  long[rendez#filelock] := locknew + 1
  mem.mallocinit1(200, rendez#start)
  AddToCogTable(0, 1, string("bootsim.binary"), 0, long[rendez#memfreelist])

  ' Start up the serial driver
  StartDriver(@serial1, string("serialsim.binary"))
  repeat while not ser.gethandle1 ' Wait till serial driver ready     
  start1

  ' Start up the file system driver
  StartDriver(@fileio1, string("kernelsim.binary"))

  if fileio.mount_explicit(0, 0, 0, 0) =< 0
    conio.str(STRING("\nmount failed.", 13))
    repeat
  fileio.chdir(string("/"))

  ' Start up the shell
  argv1[0] := string("/shell")
  argv1[1] := string("boot")
  fileio.run(2, @argv1, 1)

  repeat

PUB AddToCogTable(cognum, type, name, startaddr, size) | entryptr
  entryptr := rendez#cogtable + (cognum * 24)
  byte[entryptr] := type
  bytemove(entryptr+1, name, 19)
  byte[entryptr+19] := 0
  word[entryptr+20] := startaddr
  word[entryptr+22] := size

DAT
  fileio1 FILE "kernelsim.binary"
  serial1 FILE "serialsim.binary"

PUB StartDriver(dataddr, name) | AppAddr, size, i, cognum
  size := word[dataddr + $a] ' Start of stack
  ' Allocate the memory plus some for the stack
  AppAddr := mem.calloc(size + 800)
  ifnot AppAddr
    conio.str(string("Not enough memory to run "))
    conio.str(name)
    conio.tx(13)
    return
  bytemove(AppAddr, dataddr, size)
  ' Fixup
  repeat i from 0 to 4
    word[AppAddr+6+i<<1] += AppAddr
  ' Fill the stack with the check word
  longfill(AppAddr + size, rendez#checkword, 200)
  long[AppAddr + size]~
  cognum := cognew($f004, AppAddr + 4)
  AddToCogTable(cognum, 1, name, AppAddr, size + 800)

PUB start1 | stdio, stdin, stdout
{{
  This routine calls the malloc initialization routine.  The number of longs in
  the top object stack is set by the value of "stacksize".  It also calls the
  openserial function to initialize the standard I/O serial port.  It returns the
  stdio pointer if successful, or NULL if not.
}}
  stdio := openserial
  stdin := mem.malloc(file_info_size)
  stdout := mem.malloc(file_info_size)
  long[rendez#stdio] := stdio
  long[rendez#stdin] := stdin
  long[rendez#stdout] := stdout
  bytemove(stdin, stdio, file_info_size)
  bytemove(stdout, stdio, file_info_size)
  return stdio

PUB openserial | pfileinfo
{{
  This routine allocates memory for a file info and serial port data structure.
  It calls the start1 function in the cserial object to create a serial port in
  the next available cog.  It returns a pointer to the file info structure if
  successful, or a NULL value if not successful.
}}
  pfileinfo := mem.malloc(file_info_size)
  ifnot pfileinfo
    conio.str(string("openserial: malloc failed", 13))
    return 0
  long[pfileinfo][file_info_type] := file_info_serial
  long[pfileinfo][file_info_data] := ser.gethandle1
  return pfileinfo