CON
  _clkmode = xinput
  _xinfreq = $4E495053 ' SPIN

OBJ
  c : "clib_os"

PUB main(argc, argv) | ptr, fname, value, setmask, setflag, bitpos
  if argc <> 3
    usage

  ptr := long[argv][1]
  fname := long[argv][2]

  if byte[ptr] => "0" AND byte[ptr] =< "7"
    c.sscanf1(ptr, string("%o"), @setmask)
    c.chmod(fname, setmask)
    c.exit(0)

  if byte[ptr] <> "+" AND byte[ptr] <> "-"
    usage

  setmask := c.getmod(fname)

  if (setmask == -1)
    nofile(fname)

  setflag := 1
  repeat while byte[ptr]
    value := byte[ptr++]
    if value == "+"
      setflag := 1
      next
    elseif value == "-"
      setflag := 0
      next
    elseif value == "x"
      bitpos := 1
    elseif value == "w"
      bitpos := 2
    elseif value == "r"
      bitpos := 4
    elseif value == "d"
      bitpos := 8
    else
      usage

    if setflag
      setmask |= bitpos
    else
      setmask &= (bitpos ^ %1111)

  c.chmod(fname, setmask)

PUB nofile(fname)
  c.printf1(string("Could not find %s\n"), fname)
  c.exit(0)

PUB usage
  c.printf0(string("usage: chmod mode file\n"))
  c.printf0(string("  mode is either an octal number or\n"))
  c.printf0(string("  contains the characters +-drwx\n"))
  c.exit(0)
