CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

OBJ
  fileio : "cfileiosim"
  rendez : "rendezvous"
  
CON
  pFileCommand = rendez#filecmd
  pFileParms   = rendez#fileparm

PUB CommandProcessor | Command, retval, arg1, arg2, arg3, arg4, cognum
  long[pFileCommand] := 0

  ' Wait for a kernel command
  repeat
    repeat while long[pFileCommand] == 0
    Command := long[pFileCommand]
    cognum := (Command >> 16) & 7
    Command &= $ffff
    longmove(@arg1, long[pFileParms], 4)
    case Command
      1:  retval := fileio.fgetc(arg1)
      2:  retval := fileio.fgets(arg1, arg2, arg3)
      3:  retval := fileio.fopen(arg1, arg2)
      4:  retval := fileio.fread(arg1, arg2, arg3, arg4)
      5:  retval := fileio.fwrite(arg1, arg2, arg3, arg4)
      6:  retval := fileio.fclose(arg1)
      7:  retval := fileio.remove(arg1)
      8:  retval := fileio.rename(arg1, arg2)
      9:  retval := fileio.create(arg1)
      10: retval := fileio.getfilesize(arg1)
      11: retval := fileio.mount_explicit(arg1, arg2, arg3, arg4)
      12: retval := fileio.getcwd(arg1, arg2)
      13: retval := fileio.chdir(arg1)
      '14: retval := fileio.format(arg1)
      15: retval := fileio.opendir(arg1)
      16: retval := fileio.readdir(arg1)
      17: retval := fileio.closedir(arg1)
      18: retval := fileio.ftell(arg1)
      19: retval := fileio.fseek(arg1, arg2, arg3)
      20: retval := fileio.fflush(arg1)
      21: retval := fileio.mkdir(arg1)
      22: retval := fileio.chmod(arg1, arg2)
      23: retval := fileio.getmod(arg1)
      24: retval := fileio.run(arg1, arg2, arg3)
      25: retval := fileio.kill(arg1)
      other: retval := -1000
    long[pFileParms] := retval
    long[pFileCommand] := 0

    ' Clear the file lock if the calling cog is no longer running
    if (Command == 25 and arg1 == cognum) or (Command == 24 and arg3 == cognum + 1)
      lockclr(long[rendez#filelock] - 1)